︠39d9b08e-c568-4c6a-9d51-41dc9eb59b77s︠
reset()
typeset_mode(True)
︡d0eee90d-1c36-49a5-b4dd-bac36c553906︡︡{"done":true}
︠a294aa10-d3a3-4679-be01-0ade49109b10s︠
def all_paths(G,a,b):
    old_paths = G.all_paths( a, b ) # get all paths without edge multiplicity
    new_paths=[]
    for p in old_paths: # traverse each path replacing each edge by a list of (multi) edges
        multi_path=[]
        for i,u in enumerate(p):
            if i < len(p)-1:
                v = p[i+1]
                edges = G.edge_boundary([u], [v] )
                multi_path.append(edges)
        new_paths.extend( CartesianProduct(*multi_path )) # each sequence of (multi) edges will be a source of multiple paths
        #new_paths.extend( cartesian_product(*multi_path ))
    return new_paths
︡8eb70192-3894-4010-9b8e-83b145ad214f︡︡{"done":true}
︠b9b0a255-c948-44c7-ba40-a10a0a4ae5f2s︠
# start is at position 1 and end is position 5
_ = var('start')
_ = var('end')
︡835eda42-b081-4617-8c2c-b0207c199405︡︡{"done":true}
︠d0b3f6b9-c447-42b5-bc5b-b5615cdea90cs︠
# define all the positions
for i in ['8','16']:
            for l in [1,3,5,7]:
                _ = var('_'+str(i)+'Pos'+str(l))
︡fd54698e-271a-423b-adb7-7c32e9f9c834︡︡{"done":true}
︠40d26f7a-2065-4542-83ec-cabc59378562s︠
#Add arrows for calls, small subset, rest are at end

reset('D')
# create the graph
D = DiGraph(multiedges=True)



for i in ['MDsD1']:
    D.add_edge((start,_8Pos1,str(i)))
    D.add_edge((_16Pos5,end,str(i)))
    for j in [[1,1],[3,3],[5,5],[7,7]]:
        for k in [['_8','_16']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['HH']:
    D.add_edge((start,_8Pos3,str(i)))
    D.add_edge((_16Pos7,end,str(i)))
    for j in [[1,3],[3,1],[5,7],[7,5]]:
        for k in [['_8','_16']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['RsLs']:
    D.add_edge((_16Pos7,end,str(i)))
    for j in [[5,7],[7,5]]:
        for k in [['_8','_16']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))

for i in ['BRCT']:
    D.add_edge((start,_8Pos7,str(i)))
    D.add_edge((_16Pos3,end,str(i)))
    for j in [[1,7],[3,5],[5,3],[7,1]]:
        for k in [['_8','_16']]:
            D.add_edge(var(str(k[0])+'Pos'+str(j[0])),var(str(k[1])+'Pos'+str(j[1])),str(i))


︡59fa348a-46eb-4e2c-af4e-2869e757d4e8︡︡{"done":true}
︠1f7d484c-eafb-414b-8469-bb5ee870f7a6s︠
# show the graph, it's not pretty...yet
len(set(D.vertices()))
#D.graphplot(edge_labels=True,layout='circular').show()
D.graphplot(edge_labels=True,layout='circular').show()
D.get_pos()
#positions = D.get_pos()
#positions
#D.get_pos()
︡0db89c84-9a35-4590-8907-d243c670bbc1︡︡{"html":"<div align='center'>$\\displaystyle 10$</div>"}︡{"file":{"filename":"/projects/f5131d05-a281-4a3b-b456-e738f4182eb1/.sage/temp/compute6-us/7707/tmp_wE5VUW.svg","show":true,"text":null,"uuid":"2076cfb3-ca77-4579-9883-c21b5fd2e1e6"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠13896cee-2181-464b-931d-ef9c8c69ed02s︠
# count the dances
paths=all_paths(D,start,end)
len(paths)
︡16d7e180-8ec5-4f33-a4db-ab11f5614308︡︡{"stderr":"<string>:11: DeprecationWarning: CartesianProduct is deprecated. Use cartesian_product instead\nSee http://trac.sagemath.org/18411 for details.\n"}︡{"html":"<div align='center'>$\\displaystyle 9$</div>"}︡{"done":true}
︠8f4261e4-d069-4233-83a0-4f30dc24bb6cs︠
D.set_pos({
        start:[0,4],
        _8Pos1:[1,5.5],
        _8Pos3:[1,4.5],
        _8Pos5:[1,3.5],
        _8Pos7:[1,2.5],
        _16Pos1:[2,5.5],
        _16Pos3:[2,4.5],
        _16Pos5:[2,3.5],
        _16Pos7:[2,2.5],
        end:[3,4]
    })

︡43085bae-b217-4808-afce-f7a4431a229c︡︡{"done":true}
︠41fc51fe-7692-4fd3-8702-dab49e6371b2s︠
D.graphplot(edge_labels=True, vertex_size=3000).plot(figsize=12)
K = D.graphplot(edge_labels=True, vertex_size=3000).plot(figsize=12)
︡c82ad628-d740-44ab-9bc9-c5adc23b63a6︡︡{"file":{"filename":"/projects/f5131d05-a281-4a3b-b456-e738f4182eb1/.sage/temp/compute6-us/7707/tmp_8twRW0.svg","show":true,"text":null,"uuid":"88d808bd-3124-4ffe-8d81-c4eb2ab0fd67"},"once":false}︡{"html":"<div align='center'></div>"}︡{"done":true}
︠dce70ea6-3924-470c-acfd-482d52c515f8s︠
K.save('paperplot.png')
︡6f8f2751-3a02-4c2f-9c57-ba5771f921c6︡︡{"done":true}
︠847ce24a-b0cd-44c3-85ee-7d464a0a42b4s︠
D.get_pos()
︡0f1f3088-2954-4fa7-a803-fbd2e39bac74︡︡{"html":"<div align='center'>$\\displaystyle \\left\\{\\mathit{A1bPos}_{5} : \\left[2, 3.50000000000000\\right], \\mathit{A1bPos}_{7} : \\left[2, 2.50000000000000\\right], \\mathit{A1aPos}_{5} : \\left[1, 3.50000000000000\\right], \\mathit{A1aPos}_{7} : \\left[1, 2.50000000000000\\right], \\mathit{A1bPos}_{1} : \\left[2, 5.50000000000000\\right], \\mathit{A1bPos}_{3} : \\left[2, 4.50000000000000\\right], \\mathit{start} : \\left[0, 4\\right], \\mathit{end} : \\left[3, 4\\right], \\mathit{A1aPos}_{1} : \\left[1, 5.50000000000000\\right], \\mathit{A1aPos}_{3} : \\left[1, 4.50000000000000\\right]\\right\\}$</div>","done":false}︡{"done":true}
︠93f70321-b0fd-4db0-9051-c8939522cc14s︠
for p in paths:
    print p
︡091e9f38-a6ac-4270-9461-0eb2dbd6052e︡︡{"stdout":"((start, A1aPos1, 'MDsD1'), (A1aPos1, A1bPos7, 'BRCT'), (A1bPos7, end, 'HH'))\n((start, A1aPos1, 'MDsD1'), (A1aPos1, A1bPos7, 'BRCT'), (A1bPos7, end, 'RsLs'))\n((start, A1aPos1, 'MDsD1'), (A1aPos1, A1bPos3, 'HH'), (A1bPos3, end, 'BRCT'))\n((start, A1aPos3, 'HH'), (A1aPos3, A1bPos5, 'BRCT'), (A1bPos5, end, 'MDsD1'))\n((start, A1aPos3, 'HH'), (A1aPos3, A1bPos3, 'MDsD1'), (A1bPos3, end, 'BRCT'))\n((start, A1aPos7, 'BRCT'), (A1aPos7, A1bPos5, 'HH'), (A1bPos5, end, 'MDsD1'))\n((start, A1aPos7, 'BRCT'), (A1aPos7, A1bPos5, 'RsLs'), (A1bPos5, end, 'MDsD1'))\n((start, A1aPos7, 'BRCT'), (A1aPos7, A1bPos7, 'MDsD1'), (A1bPos7, end, 'HH'))\n((start, A1aPos7, 'BRCT'), (A1aPos7, A1bPos7, 'MDsD1'), (A1bPos7, end, 'RsLs'))\n","done":false}︡{"done":true}
︠5ba276de-2427-472b-92df-83529ba46665︠
D.show(edge_labels=True,layout='spring',iterations=20000)
︡e3956ac5-a467-4068-b691-c801c3c810eb︡︡{"once":false,"done":false,"file":{"show":true,"uuid":"c0c9d108-fdd4-4259-9191-f2c3ee03693c","filename":"/projects/f5131d05-a281-4a3b-b456-e738f4182eb1/.sage/temp/compute6-us/28693/tmp_hl1IA6.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠15aa3921-285c-45be-a2e1-08d365ea3776︠
D.show()
︡83434fc7-305e-4164-92a2-f7e399245a91︡︡{"once":false,"done":false,"file":{"show":true,"uuid":"b0fe64ec-272c-4cec-9035-065d1d903971","filename":"/projects/f5131d05-a281-4a3b-b456-e738f4182eb1/.sage/temp/compute6-us/28693/tmp_XC_p4V.svg"}}︡{"html":"<div align='center'></div>","done":false}︡{"done":true}
︠484fe73a-221d-4598-aac2-418e4abfa2a0︠









